# KEKS -- Python KEKS implementation
# Copyright (C) 2024-2025 Anton Rudenko <rudenko.ad@phystech.edu>
#               2024-2025 Sergey Matveev <stargrave@stargrave.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.

from unittest import TestCase

from keks import _byte
from keks import DecodeError
from keks import loads
from keks import TagBlob
from keks import TagList
from keks import TagPInt


class TestTooDeepInt(TestCase):
    def runTest(self) -> None:
        with self.assertRaises(DecodeError) as err:
            loads(_byte(TagPInt) + _byte(TagList) * 1000)
        self.assertEqual(str(err.exception), "unknown tag")


class TestTooDeepBlob(TestCase):
    def runTest(self) -> None:
        with self.assertRaises(DecodeError) as err:
            loads(_byte(TagBlob) + (8 * b"\x01") + _byte(TagList) * 1000)
        self.assertEqual(str(err.exception), "unknown tag")


class TestTooDeepList(TestCase):
    def runTest(self) -> None:
        with self.assertRaises(DecodeError) as err:
            loads(_byte(TagList) * 1000)
        self.assertEqual(str(err.exception), "deep recursion")
